#ifndef SPACENAV_H
#define SPACENAV_H

#include <stdio.h>
#include <wchar.h>
#include <string.h>
#include <stdlib.h>
#include "hidapi/hidapi.h"
#include <qdebug.h>
#include <QWidget>
#include <QTimer>


class SpaceNav: public QObject
{
    Q_OBJECT  // must include this if you use Qt signals/slots

    public:
		enum Actions{ Translation = 1, Rotation, PressedButton };
		enum Buttons{ LeftButton = 1, RigthButton};
        SpaceNav();

        static const int changeMinValue = 10;
        static const int POSITIVE = 0;
        static const int  NEGATIVE = 0xff;

        void analyzeData();
        void printData(int action);

		void setMainWidget( QWidget *w ) {
			glWidget = w;
		}
		void setTimer( int v )
		{
			timer1->start(v);
		}

	public slots:
		void sampling( void );

	private:
		QWidget *glWidget;
		int action, result;
        unsigned char buf[256];
        hid_device *handle;
		QTimer *timer1;
		int b, x, y, z, t1, t2, t3;
};

#endif // SPACENAV_H
